import java.awt.*;
import java.awt.event.*;

class ClientConnectPanel extends Panel {
    private Insets mInsets                 = new Insets(3,3,3,3);
    private Label       connectHostLabel;
    private Label       connectPortLabel;
    private TextField   connectHostField;
    private TextField   connectPortField;
    private Button      connectButton;
    private GridBagLayout gb = new GridBagLayout();
    private GridBagConstraints gbc = new GridBagConstraints();
    private int row = 0;
    private ActionListener al;
    private String      host;
    private String      port;

    public ClientConnectPanel (ActionListener a) {
        al = a;

        setBackground(Color.lightGray);
        setLayout(gb);

        gbc.anchor      = GridBagConstraints.CENTER;
        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridwidth   = GridBagConstraints.REMAINDER;
        gbc.gridx       = 0;
        gbc.gridy       = row;
        gbc.gridwidth   = 1;
        gbc.gridheight  = 1;
        connectHostLabel = makeLabel("Host: ", 12, 1);

        gbc.gridx       = 1;
        connectHostField = makeTextField("", false);

        row += 2;

        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridx       = 0;
        connectPortLabel = makeLabel("Port: ", 12, 1);

        gbc.fill        = GridBagConstraints.NONE;
        gbc.gridx       = 1;
        connectPortField = makeTextField("", false);

        row += 2;

        gbc.gridx       = 0;
        gbc.gridwidth   = GridBagConstraints.REMAINDER;
        connectButton = makeButton("Connect");
    }

    protected
    TextField  makeTextField(String name,
                             boolean passwd) {

        gbc.gridy = row;
        TextField field = new TextField(20);
        if (passwd) {
            field.setEchoChar('*');
        }
        field.addActionListener(al);
        gb.setConstraints(field, gbc);
        add(field);

        return field;
    }

    protected
    Label makeLabel(String name,
                    int size,
                    int position) {

        gbc.gridy = row;
        Label label;
        if (position == 0) {
            label = new Label(name, Label.CENTER);
        } else {
            label = new Label(name, Label.RIGHT);
        }

        label.setFont(new Font("Helvetica", Font.BOLD, size));
        gb.setConstraints(label, gbc);
        add(label);

        return label;
    }

    protected
    Button makeButton(String name) {

        gbc.gridy = row;
        Button button = new Button(name);
        button.addActionListener(al);
        gb.setConstraints(button, gbc);
        add(button);

        return button;
    }

    public Insets
    getInsets()
    {
        return mInsets;
    }

    public String
    getHost() {
        return connectHostField.getText();
    }

    public int
    getPort() {
        return Integer.parseInt(connectPortField.getText());
    }

    public void
    clearTexts() {
        connectHostField.setText("");
        connectPortField.setText("");
    }

    public void
    setTexts(String s, int p) {
        host = s;
        port = Integer.toString(p);
        resetTexts();
    }

    public void
    resetTexts() {
        connectHostField.setText(host);
        connectPortField.setText(port);
    }
}
